'use strict';(function(exports){var WifiManager={SCAN_TIMEOUT:10000,init:function(){this.wifi=WifiHelper.getWifiManager();if(!this.wifi){return;}
this.changeStatus();this._settings=navigator.mozSettings;if(this._settings){this.enable();}
this.currenNetwork=this.wifi?this.wifi.connection.network:null;if(this.currenNetwork!==null){this.wifi.forget(this.currenNetwork);this.currenNetwork=null;}
window.addEventListener('wifiRefresh',this.refresh.bind(this));window.addEventListener('wifiConnect',this.connect.bind(this));window.addEventListener('wifiForget',this.disconnect.bind(this));},getNetworks:function(callback){this.networks?callback(this.networks):this.scan(callback);},scan:function(callback){if(this._scanning){return;}
this.onScan=callback;this._scanning=true;var req=this.wifi?this.wifi.getNetworks():null;if(!req){this._scanning=false;return;}
var handleRequest=()=>{this._scanning=false;clearTimeout(this.scanTimeout);this.scanTimeout=null;this.onScan(this.networks);this.onScan=null;};req.onsuccess=()=>{this.networks=req.result;handleRequest();};req.onerror=()=>{this.networks=[];handleRequest();};if(!this.scanTimeout){this.scanTimeout=setTimeout(()=>{this._scanning=false;this.onScan();},this.SCAN_TIMEOUT);}},enable:function(){this._settings.createLock().set({'wifi.enabled':true});},refresh:function(){if(App.wifiPanel){this.scan(networks=>{App.wifiPanel.render(networks);});}},getNetworkObj:function(ssid){var list=this.networks;for(var i=0,len=list.length;i<len;i++){if(list[i].ssid===ssid){return list[i];}}
return null;},connect:function(event){var target=event.detail.target;var ssid=target.dataset.ssid;var selectedNetwork=this.getNetworkObj(ssid);if(!selectedNetwork){return;}
if(WifiHelper.isOpen(selectedNetwork)){this.wifi.associate(selectedNetwork);this.currenNetwork=selectedNetwork;return;}
this.securedWifiConfig(ssid);},disconnect:function(event){var target=event.detail.target;var ssid=target.dataset.ssid;if(this.currenNetwork!==null&&this.currenNetwork.ssid==ssid){var req=this.wifi.forget(this.currenNetwork);req.onsuccess=()=>{this.currenNetwork=null;};}},securedWifiConfig:function(ssid){App.wifiAuthPanel.setTitle('',ssid);App.wifiAuthPanel.render();},securedWifiConnect:function(ssid,password,user){var network=this.getNetworkObj(ssid);if(!network){return false;}
WifiHelper.setPassword(network,password,user,'PEAP');var req=this.wifi.associate(network);req.onsuccess=()=>{this.currenNetwork=network;};},changeStatus:function(){if(WifiManager.wifi){WifiManager.wifi.onstatuschange=function(event){var status=event.status;switch(status){case'connecting':case'associated':case'authenticating':case'connected':case'disconnected':break;case'dhcpfailed':Message.show('wifi-join-fail',event.network.ssid);break;case'authenticationfailed':Message.show('wifi-connect-fail',event.network.ssid);break;case'associationreject':Message.show('wifi-ip-set-fail');break;default:break;}
App.wifiPanel.updateNetworksStatus(event.network,status);};}}};exports.WifiManager=WifiManager;}(window));